/*
 File: fsm_phrase_th.h
 Date and Time: Fri Jan 30 18:55:12 2015 
*/
#ifndef __fsm_phrase_th_h__
#define __fsm_phrase_th_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "identifier.h"
#include "c_string.h"
#include "fsm_class_phrase_th.h"
#include "o2_externs.h"
  
extern yacco2::Thread_entry ITH_fsm_phrase_th;

extern yacco2::State S1_Cfsm_phrase_th;
namespace NS_fsm_phrase_th {
yacco2::THR _YACCO2_CALL_TYPE
TH_fsm_phrase_th(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_fsm_phrase_th(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[30];
};
class Cfsm_phrase_th: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rfsm_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rfsm_phrase_ = 1
   ,R_Ropen_par_ = 570//start_of_rule_list + 2
    ,rhs1_Ropen_par_ = 2
    ,rhs2_Ropen_par_ = 3
   ,R_Rclose_par_ = 571//start_of_rule_list + 4
    ,rhs1_Rclose_par_ = 4
    ,rhs2_Rclose_par_ = 5
   ,R_Rparameters_ = 572//start_of_rule_list + 6
    ,rhs1_Rparameters_ = 6
   ,R_Rfsm_id_phrase_ = 573//start_of_rule_list + 8
    ,rhs1_Rfsm_id_phrase_ = 7
   ,R_Rfsm_id_ = 574//start_of_rule_list + 10
    ,rhs1_Rfsm_id_ = 8
    ,rhs2_Rfsm_id_ = 9
    ,rhs3_Rfsm_id_ = 10
   ,R_Rfsm_id_name_ = 575//start_of_rule_list + 12
    ,rhs1_Rfsm_id_name_ = 11
    ,rhs2_Rfsm_id_name_ = 12
    ,rhs3_Rfsm_id_name_ = 13
   ,R_Rfsm_filename_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rfsm_filename_phrase_ = 14
    ,rhs2_Rfsm_filename_phrase_ = 15
   ,R_Rfsm_filename_ = 577//start_of_rule_list + 16
    ,rhs1_Rfsm_filename_ = 16
    ,rhs2_Rfsm_filename_ = 17
    ,rhs3_Rfsm_filename_ = 18
   ,R_Rfsm_filename_name_ = 578//start_of_rule_list + 18
    ,rhs1_Rfsm_filename_name_ = 19
    ,rhs2_Rfsm_filename_name_ = 20
    ,rhs3_Rfsm_filename_name_ = 21
   ,R_Rfsm_namespace_phrase_ = 579//start_of_rule_list + 20
    ,rhs1_Rfsm_namespace_phrase_ = 22
    ,rhs2_Rfsm_namespace_phrase_ = 23
   ,R_Rfsm_namespace_ = 580//start_of_rule_list + 22
    ,rhs1_Rfsm_namespace_ = 24
    ,rhs2_Rfsm_namespace_ = 25
    ,rhs3_Rfsm_namespace_ = 26
   ,R_Rfsm_namespace_name_ = 581//start_of_rule_list + 24
    ,rhs1_Rfsm_namespace_name_ = 27
    ,rhs2_Rfsm_namespace_name_ = 28
    ,rhs3_Rfsm_namespace_name_ = 29
   ,R_Rfsm_class_phrase_ = 582//start_of_rule_list + 26
    ,rhs1_Rfsm_class_phrase_ = 30
    ,rhs2_Rfsm_class_phrase_ = 31
   ,R_Rfsm_class_ = 583//start_of_rule_list + 28
    ,rhs1_Rfsm_class_ = 32
    ,rhs2_Rfsm_class_ = 33
    ,rhs3_Rfsm_class_ = 34
   ,R_Rfsm_class_name_ = 584//start_of_rule_list + 30
    ,rhs1_Rfsm_class_name_ = 35
    ,rhs2_Rfsm_class_name_ = 36
   ,R_Rfsm_version_phrase_ = 585//start_of_rule_list + 32
    ,rhs1_Rfsm_version_phrase_ = 37
    ,rhs2_Rfsm_version_phrase_ = 38
   ,R_Rfsm_version_ = 586//start_of_rule_list + 34
    ,rhs1_Rfsm_version_ = 39
    ,rhs2_Rfsm_version_ = 40
    ,rhs3_Rfsm_version_ = 41
   ,R_Rfsm_version_string_ = 587//start_of_rule_list + 36
    ,rhs1_Rfsm_version_string_ = 42
    ,rhs2_Rfsm_version_string_ = 43
    ,rhs3_Rfsm_version_string_ = 44
   ,R_Rfsm_date_phrase_ = 588//start_of_rule_list + 38
    ,rhs1_Rfsm_date_phrase_ = 45
    ,rhs2_Rfsm_date_phrase_ = 46
   ,R_Rfsm_date_ = 589//start_of_rule_list + 40
    ,rhs1_Rfsm_date_ = 47
    ,rhs2_Rfsm_date_ = 48
    ,rhs3_Rfsm_date_ = 49
   ,R_Rfsm_date_string_ = 590//start_of_rule_list + 42
    ,rhs1_Rfsm_date_string_ = 50
    ,rhs2_Rfsm_date_string_ = 51
    ,rhs3_Rfsm_date_string_ = 52
   ,R_Rfsm_debug_phrase_ = 591//start_of_rule_list + 44
    ,rhs1_Rfsm_debug_phrase_ = 53
    ,rhs2_Rfsm_debug_phrase_ = 54
   ,R_Rfsm_debug_ = 592//start_of_rule_list + 46
    ,rhs1_Rfsm_debug_ = 55
    ,rhs2_Rfsm_debug_ = 56
    ,rhs3_Rfsm_debug_ = 57
   ,R_Rfsm_debug_string_ = 593//start_of_rule_list + 48
    ,rhs1_Rfsm_debug_string_ = 58
    ,rhs2_Rfsm_debug_string_ = 59
    ,rhs3_Rfsm_debug_string_ = 60
   ,R_Rfsm_comments_phrase_ = 594//start_of_rule_list + 50
    ,rhs1_Rfsm_comments_phrase_ = 61
    ,rhs2_Rfsm_comments_phrase_ = 62
   ,R_Rfsm_comments_ = 595//start_of_rule_list + 52
    ,rhs1_Rfsm_comments_ = 63
    ,rhs2_Rfsm_comments_ = 64
    ,rhs3_Rfsm_comments_ = 65
   ,R_Rfsm_comments_string_ = 596//start_of_rule_list + 54
    ,rhs1_Rfsm_comments_string_ = 66
    ,rhs2_Rfsm_comments_string_ = 67
    ,rhs3_Rfsm_comments_string_ = 68
   ,R_Rlint_ = 597//start_of_rule_list + 56
    ,rhs1_Rlint_ = 69
    ,rhs2_Rlint_ = 70
   ,R_Rlint_epi_ = 598//start_of_rule_list + 58
    ,rhs1_Rlint_epi_ = 71
    ,rhs2_Rlint_epi_ = 72
  };
  //no of la sets = 8
  //no of states = 139
  Cfsm_phrase_th();
  ~Cfsm_phrase_th();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[73];
  
    public:
    T_fsm_phrase* fsm_phrase_;
  
 };
struct Rfsm_phrase;
struct Ropen_par;
struct Rclose_par;
struct Rparameters;
struct Rfsm_id_phrase;
struct Rfsm_id;
struct Rfsm_id_name;
struct Rfsm_filename_phrase;
struct Rfsm_filename;
struct Rfsm_filename_name;
struct Rfsm_namespace_phrase;
struct Rfsm_namespace;
struct Rfsm_namespace_name;
struct Rfsm_class_phrase;
struct Rfsm_class;
struct Rfsm_class_name;
struct Rfsm_version_phrase;
struct Rfsm_version;
struct Rfsm_version_string;
struct Rfsm_date_phrase;
struct Rfsm_date;
struct Rfsm_date_string;
struct Rfsm_debug_phrase;
struct Rfsm_debug;
struct Rfsm_debug_string;
struct Rfsm_comments_phrase;
struct Rfsm_comments;
struct Rfsm_comments_string;
struct Rlint;
struct Rlint_epi;
struct Rfsm_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rparameters:public yacco2::CAbs_lr1_sym {
  Rparameters(yacco2::Parser* P);
  public:
};

struct Rfsm_id_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_id_phrase(yacco2::Parser* P);
  public:
};

struct Rfsm_id:public yacco2::CAbs_lr1_sym {
  Rfsm_id(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_id_name:public yacco2::CAbs_lr1_sym {
  Rfsm_id_name(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_filename_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_filename_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_filename:public yacco2::CAbs_lr1_sym {
  Rfsm_filename(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_filename_name:public yacco2::CAbs_lr1_sym {
  Rfsm_filename_name(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_namespace_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_namespace_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_namespace:public yacco2::CAbs_lr1_sym {
  Rfsm_namespace(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_namespace_name:public yacco2::CAbs_lr1_sym {
  Rfsm_namespace_name(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_class_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_class_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_class:public yacco2::CAbs_lr1_sym {
  Rfsm_class(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_class_name:public yacco2::CAbs_lr1_sym {
  Rfsm_class_name(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rfsm_version_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_version_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_version:public yacco2::CAbs_lr1_sym {
  Rfsm_version(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_version_string:public yacco2::CAbs_lr1_sym {
  Rfsm_version_string(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_date_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_date_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_date:public yacco2::CAbs_lr1_sym {
  Rfsm_date(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_date_string:public yacco2::CAbs_lr1_sym {
  Rfsm_date_string(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_debug_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_debug_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_debug:public yacco2::CAbs_lr1_sym {
  Rfsm_debug(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_debug_string:public yacco2::CAbs_lr1_sym {
  Rfsm_debug_string(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rfsm_comments_phrase:public yacco2::CAbs_lr1_sym {
  Rfsm_comments_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rfsm_comments:public yacco2::CAbs_lr1_sym {
  Rfsm_comments(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfsm_comments_string:public yacco2::CAbs_lr1_sym {
  Rfsm_comments_string(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Rlint_epi:public yacco2::CAbs_lr1_sym {
  Rlint_epi(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
